'From etoys4.0 of 9 October 2008 [latest update: #2336] on 17 April 2010 at 12:00:56 am'!
"Change Set:		compatFixes-bf
Date:			11 April 2010
Author:			Bert Freudenberg

Some fixes so we can install Monticello"!

Object subclass: #MCSnapshotTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Trunk-Compatibility'!

Object subclass: #ChangesOrganizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Trunk-Compatibility'!

PluggableTextMorph subclass: #PluggableTextMorphPlus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Trunk-Compatibility'!

!Array methodsFor: 'testing' stamp: 'md 7/30/2005 21:19'!
isArray
	^true! !

!Behavior methodsFor: '*trunk-compatibility' stamp: 'bf 4/19/2010 01:09'!
compile: code classified: category notifying: requestor trailer: bytes ifFail: failBlock
	"Compile code without logging the source in the changes file"

	| methodNode |
	methodNode  := self compilerClass new
				compile: code
				in: self
				"classified: category"		"not in Etoys image yet"
				notifying: requestor
				ifFail: failBlock.
	^ CompiledMethodWithNode generateMethodFromNode: methodNode trailer: bytes.! !


!Behavior methodsFor: 'traits' stamp: 'ar 12/31/2009 18:22'!
traitComposition
	"Backstop. When traits are unloaded we never have a trait composition"
	^#()! !

!Behavior methodsFor: 'traits' stamp: 'ar 1/1/2010 17:51'!
traitCompositionString
	"Backstop. Monticello needs a traitCompositionString even with traits unloaded"
	^'{}'! !

!Behavior methodsFor: 'testing method dictionary' stamp: 'ar 12/29/2009 17:26'!
includesLocalSelector: aSymbol
	^self includesSelector: aSymbol! !

!ClassDescription methodsFor: 'accessing parallel hierarchy' stamp: 'NS 4/12/2004 15:03'!
classSide
	^self theMetaClass! !

!ClassDescription methodsFor: 'accessing parallel hierarchy' stamp: 'NS 4/12/2004 15:04'!
instanceSide
	^ self theNonMetaClass! !

!ClassDescription methodsFor: 'accessing parallel hierarchy' stamp: 'al 5/9/2004 20:50'!
isClassSide
	^self == self classSide! !

!ClassDescription methodsFor: 'accessing parallel hierarchy' stamp: 'al 5/9/2004 20:50'!
isInstanceSide
	^self isClassSide not! !

!ChangesOrganizer class methodsFor: 'enumerating' stamp: 'pk 2/6/2006 09:49'!
changeSetNamed: aName
	"Return the change set of the given name, or nil if none found.  1/22/96 sw"
	^ChangeSorter changeSetNamed: aName! !

!Dictionary class methodsFor: 'instance creation' stamp: 'bgf 10/25/2006 17:08'!
newFromPairs: anArray 

	"Answer an instance of me associating (anArray at:i) to (anArray at: i+i)
	 for each odd i.  anArray must have an even number of entries."

	| newDictionary |

	newDictionary := self new: (anArray size/2).
	1 to: (anArray size-1) by: 2 do: [ :i|
		newDictionary at: (anArray at: i) put: (anArray at: i+1).
	].
	^ newDictionary

	"  Dictionary newFromPairs: {'Red' . Color red . 'Blue' . Color blue . 'Green' . Color green}. "! !

!FileStream class methodsFor: 'instance creation' stamp: 'CdG 10/19/2005 23:21'!
detectFile: aBlock do: anotherBlock
	
	| file |

	file := aBlock value.
	^ file 
		ifNil: [ nil ]
         ifNotNil: [ [anotherBlock value: file] ensure: [file close]]! !

!Encoder methodsFor: 'encoding' stamp: 'bf 4/12/2010 14:41'!
undeclared: name

	| sym |
	(requestor notNil and: [requestor interactive]) ifTrue: [
		^ self notify: 'Undeclared'].
	Transcript show: ' (' , name , ' is Undeclared) '.
	sym _ name asSymbol.
	Undeclared at: sym put: nil.
	^self global: (Undeclared associationAt: sym) name: sym! !

!FileStream class methodsFor: 'instance creation' stamp: 'bkv 1/22/2004 17:29'!
readOnlyFileNamed: fileName do: aBlock
	"Avi Bryant says, ''This idiom is quite common in other languages that make heavy use of closures (i.e. Lisp (with-file 'foo' (f) ...) and Ruby (File.open('foo'){|f|...})).  It's time Squeak had it, too.''
	
	Returns the result of aBlock."
	
	^ self detectFile: [ self readOnlyFileNamed: fileName ] do: aBlock! !

!MethodReference methodsFor: 'queries' stamp: 'ab 5/23/2003 22:58'!
category

	^ self actualClass organization categoryOfElement: methodSymbol! !

!Preferences class methodsFor: '*monticello'!
monticelloToolWindowColor
	^ self
		valueOfFlag: #monticelloToolWindowColor
		ifAbsent: [Color
				r: 0.627
				g: 0.69
				b: 0.976]! !

!String methodsFor: 'comparing' stamp: 'ul 11/2/2009 03:01'!
hashWithInitialHash: initialHash
	
	^ self class stringHash: self initialHash: initialHash! !

!Symbol methodsFor: 'testing' stamp: 'md 8/27/2005 16:33'!
isDoIt

	^ (self == #DoIt) or: [self == #DoItIn:].! !

!SystemDictionary methodsFor: 'accessing' stamp: 'bf 4/17/2010 14:17'!
globals
	^self! !

!Object methodsFor: 'testing' stamp: 'eem 5/8/2008 11:13'!
isArray
	^false! !

!Object methodsFor: 'testing' stamp: 'pmm 7/6/2006 20:46'!
isTrait
	"Return true if the receiver is a trait.
	Note: Do not override in any class except TraitBehavior."
	^false! !

!Object methodsFor: 'accessing' stamp: 'Igor.Stasenko 11/13/2009 07:19'!
enclosedSetElement
	"The receiver is included into a set as an element. 
	Since some objects require wrappers (see SetElement) to be able to be included into a Set,
	a set sends this message to its element to make sure it getting real object,
	instead of its wrapper.
	Only SetElement instance or its subclasses allowed to answer something different than receiver itself"
	
! !

!PackageInfo methodsFor: 'preamble/postscript' stamp: 'bf 4/11/2010 19:53'!
postscript: ignored! !

!PackageInfo methodsFor: 'preamble/postscript' stamp: 'bf 4/11/2010 19:53'!
preamble: ignored! !

!PluggableTextMorphPlus methodsFor: 'as yet unclassified' stamp: 'bf 4/19/2010 03:29'!
useDefaultStyler! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'ul 11/11/2009 19:38'!
replace: aBlock 
	"Evaluate aBlock with each of the receiver's elements as the argument.  
	Collect the resulting values into self."

	1 to: self size do: [ :index |
		self at: index put: (aBlock value: (self at: index)) ]! !

!SequenceableCollection methodsFor: 'enumerating' stamp: 'ab 9/17/2002 01:02'!
do: aBlock displayingProgress: aString
	aString
		displayProgressAt: Sensor cursorPoint
		from: 0 to: self size
		during:
			[:bar |
			self withIndexDo:
				[:each :i |
				bar value: i.
				aBlock value: each]]! !


!SystemDictionary methodsFor: 'accessing' stamp: 'bf 4/19/2010 03:09'!
allTraits
	^#()! !

!Set methodsFor: 'accessing' stamp: 'ul 2/19/2010 14:49'!
like: anObject ifAbsent: aBlock
	"Answer an object in the receiver that is equal to anObject,
	or evaluate the block if not found. Relies heavily on hash properties"
	
	^(array at: (self scanFor: anObject))
		ifNil: [ aBlock value ]
		ifNotNil: [ :element | element enclosedSetElement ]! !

!KeyedSet methodsFor: 'accessing' stamp: 'ul 2/19/2010 15:35'!
like: anObject ifAbsent: aBlock
	"Answer an object in the receiver that is equal to anObject,
	or evaluate the block if not found. Relies heavily on hash properties"

	^(array at: (self scanFor: (keyBlock value: anObject)))
		ifNil: [ aBlock value ]
		ifNotNil: [ :element | element enclosedSetElement ]! !

!WeakSet methodsFor: 'accessing' stamp: 'ul 2/19/2010 14:56'!
like: anObject ifAbsent: aBlock
	"Answer an object in the receiver that is equal to anObject,
	or evaluate the block if not found. Relies heavily on hash properties"

	| element |
	((element  := array at: (self scanFor: anObject)) == flag or: [ element == nil ])
		ifTrue: [ ^aBlock value ]
		ifFalse: [ ^element enclosedSetElement ]! !
